MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
sc::SCBlockInfo Class Reference

SCBlockInfo contains blocking information for the SCDimension class. More...

`#include <dim.h>`

Inheritance diagram for sc::SCBlockInfo:
[legend]
Collaboration diagram for sc::SCBlockInfo:
[legend]

## Public Member Functions
| SCBlockInfo (int n, int nblocks=0, const int *blocksizes=0)
| Create a SCBlockInfo object.
| SCBlockInfo (StateIn &)
| SCBlockInfo (const Ref< KeyVal > &keyval)
| The KeyVal constructor. More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
int | equiv (SCBlockInfo *bi)
| Return nonzero if this is equivalent to bi.
int | nelem () const
| Return the total number of elements.
int | nblock () const
| Return the number of blocks.
int | start (int i) const
| Return the starting index for block i.
int | size (int i) const
| Return the size of block i.
int | fence (int i) const
| Return the last index + 1 for block i.
void | elem_to_block (int i, int &block, int &offset)
RefSCDimension | subdim (int i)
| Retreive subdimension information.
void | set_subdim (int i, const RefSCDimension &dim)
| Set subdimension information. More...
void | print (std::ostream &o=ExEnv::out0()) const
| Print the object to the stream o.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Member Functions
void | init_start ()
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Protected Attributes
int | n_
int | nblocks_
int * | start_
int * | size_
RefSCDimension * | subdims_

## Additional Inherited Members
Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)

## Detailed Description

SCBlockInfo contains blocking information for the SCDimension class.

There are really two ways that it can contain blocking information. In the first way, a vector of block offsets and block sizes is stored. The second method is only used by those specializations created by the BlockedSCMatrixKit class. In this method the blocking information is stored as subdimensions of type SCDimension. If both methods are used, they must be used consistently. That is, the number, sizes, and order of the blocks must match the number, sizes, and order of the SCDimension objects.

## Constructor & Destructor Documentation

sc::SCBlockInfo::SCBlockInfo | ( | const Ref< KeyVal > & | keyval | ) |

The KeyVal constructor.

`sizes`

  This is a vector giving the size of each subblock. There is no default.

`subdims`

  If this vector is given there is must be entry for each entry in the sizes vector. Each entry is an SCDimension object. The default is to not store subdimension information.

## Member Function Documentation

void sc::SCBlockInfo::save_data_state | ( | StateOut & |  | ) |
| virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

void sc::SCBlockInfo::set_subdim | ( | int | i,
|  | const RefSCDimension & | dim
| ) |  |

Set subdimension information.

The dimension dim and index i must be consistent with the nblocks and blocksizes information given to the constructor.

The documentation for this class was generated from the following file:

- dim.h